#pragma once


#include "V3.h"
#include "ppc.h"
#include "framebuffer.h"
#include "IFB.h"

class TM {
public:
	V3 *verts, *colors, *normals, *pverts, *tcs;
	// TEXTUREHINT: tcs has to be float *tcs; of length 2*vertsN for HW texturing
	int vertsN;
	unsigned int *tris;
	int trisN;
	FrameBuffer *texture;
	int on;
	TM() : verts(0), vertsN(0), tris(0), trisN(0), colors(0), normals(0), 
		pverts(0), tcs(0), texture(0), on(1) {};
	void SetQuad(V3 v0, V3 v1, V3 v2, V3 v3);
	void Allocate(int vsN, int trsN);
	void LoadBin(char *fname);
	void RenderPoints(FrameBuffer *fb, int psize, PPC *ppc, int subSet = -1);
	void RenderFilled(FrameBuffer *fb, PPC *ppc);
	void RenderHW();
	void PixelAccurateShadows(IFB *ifb, PPC *ppc, FrameBuffer *outputImage);
	void RenderWF(FrameBuffer *fb, PPC *ppc);
	void Translate(V3 tv);
	V3 GetCenter();
	void Rotate(V3 aO, V3 aD, float theta);
	void Light(V3 L, float ka);
	void VisualizeNormals(float d, PPC *visppc, FrameBuffer *visfb);
	void SetAllColors(V3 col);
	AABB GetAABB();
	void Scale(float scf);
	void SetDisk(int sectorsN);
	int IntersectWithRay(V3 rayO, V3 rayD, float& it, V3& barry, V3& intPoint);
};